#if 1
//#define ASM
#include "fat.h"        /*for field offsets*/
#include "standalone.h" /*for USE_EFI*/

	.import _ReadDiskSectorTo,_stream_buffer
	.import _fatInfo

	.import _GetByte
	.import _GetWord
	.import _GetLong

// auto u_int16 FatInitFileSystem(void) {

	.sect code,InitFileSystem	// 115 words -> 85 -> 79 -> 95
	.export _InitFileSystem
_InitFileSystem:	// PROLOGUE
	// stack increased in the caller
	stx I0,(I6)+1 ; sty I2,(I6)
	//ldc 512,MR0
	stx A1,(I6)+1 ; sty B0,(I6)
	stx B1,(I6)+1 ; sty C0,(I6)
	stx C1,(I6)+1 ; sty D0,(I6)
	stx D1,(I6)+1	; sty LR0,(I6)
	ldc _fatInfo,i0
	ldc FATINFO_SIZE,a0
#ifdef FATINFO_IN_Y
	.import _memsetY
	call _memsetY
	and a1,null,a1
#else
	.import _memset
	call _memset
	and a1,null,a1
#endif

//    ReadDiskSectorTo(0, stream_buffer);

	and A,NULL,A	; stx MR0,(I6)+3
	call _ReadDiskSectorTo	// Register parameter: A, pass by value
	ldc _stream_buffer,i2

	ldc _fatInfo+CURRENTSECTOR,I2

//    if (GetWord(510) != 0xaa55)
//	return 0xaa55;

	call _GetWord
	ldc 510,c0

	ldc 0xaa55,c0
	sub a0,c0,a0
	ldc 0x36,c0
	jzc $0
	ldc ('1'<<8)|'T',D1	// 'FAT1' i.e. FAT12 or FAT16

//    if (GetLong(0x36)!= (((long)'1'<<24)|((long)'T'<<16)|((long)'A'<<8)|'F') &&
//        GetLong(0x52)!= (((long)'3'<<24)|((long)'T'<<16)|((long)'A'<<8)|'F')
//        ) {
//        fatInfo.currentSector = GetLong(0x1c6);
//        ReadDiskSectorTo(fatInfo.currentSector, stream_buffer);
//    }

	call _GetLong
	ldc _fatInfo+FILSYSTYPE,I2

	ldc ('A'<<8)|'F',D0
	sub a,d,a	; ldx (i6)+2,null
	ldc ('3'<<8)|'T',D1	//and a,null,a if jump taken, A is already 0!
	jzs $6
	ldc ('A'<<8)|'F',D0	// 'FAT3' i.e. FAT32

	call _GetLong
	ldc 0x52,c0	//FAT32
	sub a,d,a	; ldx (i6)+1,null
	ldc 0x1c6,C0		//and a,null,a if jump taken, A is already 0!
	jzs $6
	nop

	// Get boot sector location
$66:	call _GetLong	// Register parameter: C0, pass by value
	ldx (I6)+1,NULL	; ldy (i2)+(CURRENTSECTOR-FILSYSTYPE),null

#ifdef FATINFO_IN_Y
	sty A0,(I2)+1	; ldx (i6)+1,null	//CURRENTSECTOR
	sty A1,(I2)+(FILSYSTYPE-CURRENTSECTOR-1)
	stx i2,(i6)+1
	call _ReadDiskSectorTo	// Register parameter: A, pass by value
	ldc _stream_buffer,i2
#else
	stx A0,(I2)+1	; ldy (i6)+1,null	//CURRENTSECTOR
	stx A1,(I2)+(FILSYSTYPE-CURRENTSECTOR-1)
	stx i2,(i6)+1
	call _ReadDiskSectorTo	// Register parameter: A, pass by value
	ldc _stream_buffer,i2
#endif

#ifdef USE_EFI /*Support EFI partitions. Pick the first one. +13 words. */
	call _GetLong	// Register parameter: C0, pass by value, auto
	and c0,null,c0	; ldx (i6)+1,i2      //offset 0, auto
	ldc (' '<<8)|'I',C1	// 'EFI PART'
	ldc ('F'<<8)|'E',C0
	sub a,c,a	; ldy (i2)+(CURRENTSECTOR-FILSYSTYPE),null
#ifdef FATINFO_IN_Y
	ldy (I2)+1,A0	//CURRENTSECTOR
	jzc $67
	ldy (I2)+(FILSYSTYPE-CURRENTSECTOR-1),A1
#else
	ldx (I2)+1,A0	//CURRENTSECTOR
	jzc $67
	ldx (I2)+(FILSYSTYPE-CURRENTSECTOR-1),A1
#endif
	//Was 'EFI ', read the next block for the partition info
	sub a,ones,a	; ldx (i6)+1,null
	call _ReadDiskSectorTo	// Register parameter: A, pass by value, auto
	ldc _stream_buffer,i2

	ldc 0x20,c0	//the location of the partition found at offset 32
	j $66		//try to find FAT again
$67:	ldx (i6)-1,i2
#else
	ldx (i6)-1,i2
#endif

$6:

//     {
// 	u_int16 BPB_BlksPerSec;

	//fatInfo.FilSysType = GetWord(54+3); /* 0x3231 for FAT12 */
	call _GetWord	     //auto
	ldc 54+3,C0
#ifdef FATINFO_IN_Y
	sty a0,(i2)+(BPBROOTENTCNT-FILSYSTYPE)
#else
	stx a0,(i2)+(BPBROOTENTCNT-FILSYSTYPE)
#endif

// 	fatInfo.BPB_RootEntCnt = GetWord(17);

	call _GetWord	// Register parameter: C0, pass by value, auto
	ldc 17,C0

// 	fatInfo.IS_FAT_32 = fatInfo.BPB_RootEntCnt ? 0 : 1;

	sub NULL,ONES,A1
#ifdef FATINFO_IN_Y
	add A0,NULL,D1	; sty A0,(I2)+(ISFAT32-BPBROOTENTCNT+5)
#else
	add A0,NULL,D1	; stx A0,(I2)+(ISFAT32-BPBROOTENTCNT+5)
#endif
	ldc 11,C0
	jzs $5
	ldx (i2)-5,null

	and NULL,NULL,A1
$5:

// 	BPB_BlksPerSec = GetWord(11) >> 9;

	call _GetWord	// Register parameter: C0, pass by value
#ifdef FATINFO_IN_Y
	sty A1,(I2)+(FATSECTORSPERCLUSTER-ISFAT32-4) ; ldx (I6)+1,NULL
#else
	stx A1,(I2)+(FATSECTORSPERCLUSTER-ISFAT32-4) ; ldy (I6)+1,NULL
#endif

	ldc 128,A1
	muluu A1,A0	; ldx (i2)+4,null	// >> 9
	add NULL,P,A ; ldx (I6)+1,NULL
	// BPB_BlksPerSec = A1

// 	fatInfo.fatSectorsPerCluster = GetByte(13) * BPB_BlksPerSec;

	call _GetByte	// Register parameter: C0, pass by value
	ldc 13,C0

	muluu A0,a1	; mv a1,D0	// BPB_BlksPerSec = D0
	add NULL,P,B	; ldy (I6)+1,NULL
#ifdef FATINFO_IN_Y
	and a1,null,a1	; sty B0,(I2)+(TOTSIZE+1-FATSECTORSPERCLUSTER)
#else
	and a1,null,a1	; stx B0,(I2)+(TOTSIZE+1-FATSECTORSPERCLUSTER)
#endif

//	totSize = GetWord(19);
//	if (totSize == 0)
//	    totSize = GetLong(32);/*TotSec32*/

	call _GetWord
	ldc 19,C0

	add a0,null,a0	; ldy (i6)+1,null	//a1 cleared above.
	ldc 32,C0
	jzc $2
	nop

	call _GetLong	/*TotSec32*/
	ldx (i6)+1,null
$2:
#ifdef FATINFO_IN_Y
	sty a1,(i2)-1
	sty a0,(i2)+(CURRENTSECTOR-TOTSIZE)
#else
	stx a1,(i2)-1
	stx a0,(i2)+(CURRENTSECTOR-TOTSIZE)
#endif

// 	fatInfo.fatStart = fatInfo.currentSector +
// 	    (u_int32)GetWord(14) * BPB_BlksPerSec;
// 	fatInfo.rootStart = GetWord(22);
// 	if (rootStart == 0)

	call _GetWord	// Register parameter: C0, pass by value
	ldc 14,C0

#ifdef FATINFO_IN_Y
	ldy (I2)+1,C0	//CURRENTSECTOR
	muluu A0,D0	; ldy (I2)+(FATSTART-CURRENTSECTOR-1),C1 //BlksPerSec
#else
	ldx (I2)+1,C0	//CURRENTSECTOR
	muluu A0,D0	; ldx (I2)+(FATSTART-CURRENTSECTOR-1),C1 //BlksPerSec
#endif
	add C,P,A	; ldx (i6)+1,null
#ifdef FATINFO_IN_Y
	sty A0,(I2)+1
	and a1,null,a1	; sty A1,(I2)+(ROOTSTART-FATSTART-1)
#else
	stx A0,(I2)+1
	and a1,null,a1	; stx A1,(I2)+(ROOTSTART-FATSTART-1)
#endif

	call _GetWord
	ldc 22,C0

#ifdef FATINFO_IN_Y
	add A0,NULL,A0	; sty A0,(I2)+1	//ROOTSTART
	sty A1,(I2)+(ISFAT32-ROOTSTART-1)	; ldx (I6)+1,NULL
	jzc $1
	ldy (I2)+(ROOTSTART-ISFAT32),A0
#else
	add A0,NULL,A0	; stx A0,(I2)+1	//ROOTSTART
	stx A1,(I2)+(ISFAT32-ROOTSTART-1)	; ldy (I6)+1,NULL
	jzc $1
	ldx (I2)+(ROOTSTART-ISFAT32),A0
#endif

//  {
// 	    if (!fatInfo.IS_FAT_32)
// 		return 0x0b;

	add A0,NULL,A0
	ldc 36,C0
	jzs $0
	ldc 11,A0

// 	    fatInfo.rootStart = GetLong(36);

	call _GetLong	// Register parameter: C0, pass by value, auto
	nop

#ifdef FATINFO_IN_Y
	sty A0,(I2)+1	; ldx (I6)+1,NULL	//ROOTSTART
	sty A1,(I2)-1
#else
	stx A0,(I2)+1	; ldy (I6)+1,NULL	//ROOTSTART
	stx A1,(I2)-1
#endif
// 	}

$1:
// 	fatInfo.rootStart = fatInfo.rootStart * (GetByte(16)  * BPB_BlksPerSec)
// 	    + fatInfo.fatStart;

	call _GetByte	// Register parameter: C0, pass by value, auto
	ldc 16,C0

#ifdef FATINFO_IN_Y
	muluu A0,D0	; ldy (I2)+1,B0	//ROOTSTART	// BPB_BlksPerSec *
	add NULL,P,C	; ldy (I2)+(FATSTART-ROOTSTART-1),B1
	muluu C0,B1	; mv C0,B1	// 16x32
	add NULL,P,A	; ldy (I2)+1,C0	//FATSTART
	muluu B1,B0	; ldy (I2)+(FATSECTORSPERCLUSTER-FATSTART-1-2),C1
	add A0,P,A	; ldy (i2)+2,null
	add A,C,C	; ldy (I2)+(ROOTSTART-FATSECTORSPERCLUSTER+1),B0
#else
	muluu A0,D0	; ldx (I2)+1,B0	//ROOTSTART	// BPB_BlksPerSec *
	add NULL,P,C	; ldx (I2)+(FATSTART-ROOTSTART-1),B1
	muluu C0,B1	; mv C0,B1	// 16x32
	add NULL,P,A	; ldx (I2)+1,C0	//FATSTART
	muluu B1,B0	; ldx (I2)+(FATSECTORSPERCLUSTER-FATSTART-1-2),C1
	add A0,P,A	; ldy (i2)+2,null
	add A,C,C	; ldx (I2)+(ROOTSTART-FATSECTORSPERCLUSTER+1),B0
#endif
	and A1,NULL,A1	; mv d1,a0
	ldc -4,d1

// 	fatInfo.dataStart = fatInfo.rootStart + (fatInfo.BPB_RootEntCnt >> 4)
// 	    - (fatInfo.fatSectorsPerCluster << 1);

	ashl a,d1,a	; mv a1,b1
	add A,C,A	; ldx (i2)-1,null
#ifdef FATINFO_IN_Y
	add B0,B0,B0	; sty C0,(I2)+1	//ROOTSTART
	sub A,B,A	; sty C1,(I2)+(DATASTART-ROOTSTART-1)
	sty A0,(I2)+1	//DATASTART
	sty A1,(I2)+(TOTSIZE-DATASTART-1-2)	; ldx (i6)+1,null
	ldy (i2)+2,null
#else
	add B0,B0,B0	; stx C0,(I2)+1	//ROOTSTART
	sub A,B,A	; stx C1,(I2)+(DATASTART-ROOTSTART-1)
	stx A0,(I2)+1	//DATASTART
	stx A1,(I2)+(TOTSIZE-DATASTART-1-2)	; ldy (i6)+1,null
	ldx (i2)+2,null
#endif
// fatInfo.numClusters = (fatInfo.totSize - fatInfo.dataStart) / fatInfo.fatSectorsPerCluster - 2;
	//dataStart in A, read totSize
#ifdef FATINFO_IN_Y
	ldy (i2)+1,B0
	ldy (i2)+(FATSECTORSPERCLUSTER-TOTSIZE-1),B1
	sub B,A,B	; ldy (i2)+(NUMCLUSTERS-FATSECTORSPERCLUSTER),A0
	.import divide32unsigned
	call divide32unsigned
	and A1,null,A1
	add a,ones,a
	add a,ones,a	//-2
	sty a0,(i2)+1
	and b,null,b	; sty a1,(i2)+(FILSYSTYPE-NUMCLUSTERS-1)
#else
	ldx (i2)+1,B0
	ldx (i2)+(FATSECTORSPERCLUSTER-TOTSIZE-1),B1
	sub B,A,B	; ldx (i2)+(NUMCLUSTERS-FATSECTORSPERCLUSTER),A0
	.import divide32unsigned
	call divide32unsigned
	and A1,null,A1
	add a,ones,a
	add a,ones,a	//-2
	stx a0,(i2)+1
	and b,null,b	; stx a1,(i2)+(FILSYSTYPE-NUMCLUSTERS-1)
#endif

#if 1 //def FAT12_SUPPORT
// 	if (fatInfo.numClusters < 4085) {
// 	    fatInfo.FilSysType = 0x3231;

	ldc lo(4085),b0
	sub a,b,b
	ldc lo(65525),b0
	jcs $29	// >=
	and NULL,NULL,b1

	ldc 0x3231,A0
	j $35
#ifdef FATINFO_IN_Y
	sty A0,(I2)
#else
	stx A0,(I2)
#endif
$29:
	ldx (i2)-7,null
	sub A,B,B	; ldx (i2)+(ISFAT32-FILSYSTYPE+7),null
#ifdef FATINFO_IN_Y
	ldy (I2),A0
#else
	ldx (I2),A0
#endif
	jcs $33
	add A0,NULL,A0	// update flags

// 	} else if (fatInfo.numClusters < 65525) {
// 	    if (fatInfo.IS_FAT_32)
// 		return 0xbad0;

	nop
	jzc $0
	ldc 0xbad0,A0

	jmpi $35
$33:

// 	} else {
// 	    if (!fatInfo.IS_FAT_32)
// 		return 0xbad1;
	nop
	jzs $0
	ldc 0xbad1,A0
$35:

// 	}
#endif

	and a0,null,a0

//     }
//     return 0;

$0:
	ldx (i6)-1,null
	ldx (I6)-1,MR0
	ldx (I6)-1,D1 ; ldy (I6),LR0
	ldx (I6)-1,C1 ; ldy (I6),D0
	ldx (I6)-1,B1 ; ldy (I6),C0
	ldx (I6)-1,A1 ; ldy (I6),B0
	jr
	ldx (I6)-1,I0 ; ldy (I6),I2
#endif
	.end
