//#define ASM
//#define STANDALONE
#include <vs1063.h>
#include "standalone.h"

//#define GPIO_IDATA GPIO_DATA
#define SPI_xCS   1 /* GPIO */
#define SPI_CLK   8
#define SPI_MISO  4
#define SPI_MISO_SHIFT -3
#define SPI_xCS2  2
#define SPI_MOSI  1 /* DREQ */


// auto void SpiSendClocks(void);

	.sect code,SpiSendClocks
	.export _SpiSendClocks
_SpiSendClocks:
#if 0
	stx a0,(i6)+1	; sty b0,(i6)
	stx ls,(i6)+1	; sty le,(i6)

	ldc 1,i5
	ldc SER_DREQ,i7
	stx i5,(i7)+(GPIO_ODATA-SER_DREQ) ; sty lc,(i6)	// DREQ=data out (=1)
	ldc 16-1,ls
	loop ls,$0-1
	nop

	nop
	ldc SPI_CLK|SPI_xCS|SPI_xCS2,b0
	ldx (i7),a0
	or a0,b0,a0	//clk+xcs+xcs2 up
	stx a0,(i7)

	nop
	nop
	ldc SPI_CLK,b0
	xor a0,b0,a0	//clk down	//ldc SPI_xCS|SPI_xCS2,i5
	stx a0,(i7)	// clk down
	//nop	//VS1003 seems to require this
$0:
	ldy (i6)-1,lc
	ldx (i6)-1,ls	; ldy (i6),le
	jr
	ldx (i6)-1,a0	; ldy (i6),b0
#else
	stx a0,(i6)+1	; sty a1,(i6)
	stx lr0,(i6)+1
	stx d0,(i6)+1	; sty c0,(i6)
	//Now saves the old state of other GPIO pins
	ldc GPIO_ODATA,i7
	or a0,ones,a0	; ldx (i7),b0	; sty b0,(i6)
	ldc ~SPI_CLK,d0
	and b0,d0,b0
	ldc 16,a1 //a1=16, a0=0xffff needed!
	ldc SPI_xCS2|SPI_CLK|SPI_xCS,c0	//MMC CS up, MMC CLK up, SPI CS up
	call _SpiCommon
	ldc SPI_xCS2|SPI_xCS,d0		//MMC CS up, MMC CLK down, SPI CS up

	ldx (i6)-1,lr0
	jr
	ldx (i6)-1,a0	; ldy (i6),a1
#endif



	.sect code,SpiSendReceiveSpi
	.export _SpiSendReceiveSpi
_SpiSendReceiveSpi:
// auto u_int16 SpiSendReceiveSpi(register __a0 u_int16 dataTopAligned, register __a1 bits);
	stx d0,(i6)+1	; sty c0,(i6)
	//Now saves the old state of other GPIO pins
	ldc GPIO_ODATA,i7
	ldx (i7),b0	; sty b0,(i6)
	ldc ~(SPI_CLK|SPI_xCS|SPI_xCS2),d0
	and b0,d0,b0
	ldc SPI_xCS2,c0	//SPI CLK up, SPI CS down, MMC CLK down
	j _SpiCommon
	ldc 0,d0	//SPI CLK down. SPI CS down, MMC CLK down

	.sect code,SpiSendReceiveMmc
	.export _SpiSendReceiveMmc16
	.export _SpiSendReceiveMmc
_SpiSendReceiveMmc16:
	ldc 16,A1
_SpiSendReceiveMmc:
// auto u_int16 SpiSendReceiveMmc(register __a0 u_int16 dataTopAligned, register __a1 bits);
	// A0 = 16-bit data to send, A0 = data read
	// I7, A1, D1 tmp regs
	stx d0,(i6)+1	; sty c0,(i6)
	ldc GPIO_ODATA,i7
	ldx (i7),b0	; sty b0,(i6)
	ldc ~(SPI_CLK|SPI_xCS|SPI_xCS2),d0
	and b0,d0,b0
	ldc SPI_CLK|SPI_xCS,c0	//MMC CLK up, SPI CS up
	ldc SPI_xCS,d0		//MMC CLK down, SPI CS up
_SpiCommon:
	or c0,b0,c0
	or d0,b0,d0	; ldy (i6),b0
	stx lc,(i6)+1	; sty c1,(i6)
	add a1,ones,c1	; stx ls,(i6)
	lsl a,a		; sty le,(i6)
	ldc SER_DREQ,i7

	loop c1,$0-1
	ldc SPI_MISO_SHIFT,c1
$1:
	// PLL3_5  55/45% clock 4.8 MHz
	// 3.5*12.288/7 = 6.144
	// 3.5*12.288/8 = 5.376
	//=3.5*12.288/9 = 4.779
	// 3.5*12.288/10 = 4.3008
	nop
	nop // as much delay between clk down and data i/o as possible
	stx a1,(i7)+(GPIO_IDATA-SER_DREQ)	//data out
	ldx (i7)+(GPIO_ODATA-GPIO_IDATA),a1	//data in, note pipeline!
	stx c0,(i7)+(GPIO_ODATA-GPIO_ODATA) // clk up   ODATA
	ashl a1,c1,a1
	nop
	nop
	lslc a,a	; stx d0,(i7)+(SER_DREQ-GPIO_ODATA)	// clk down
$0:
	ldx (i6)-1,ls	; ldy (i6),le
	ldx (i6)-1,lc	; ldy (i6),c1
	jr
	ldx (i6)-1,d0	; ldy (i6),c0

// DO DI Clkup Clkdwn


	.end
