#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "standalone.h"

__mem_y struct MMC mmc;

#if 1
auto u_int16 MmcCommand(register __b0 s_int16 cmd, register __d u_int32 arg);
#else
auto u_int16 MmcCommand(register __b0 s_int16 cmd, register __d u_int32 arg) {
    register __b1 u_int16 t;
    #if 1
        puts("Cmd(");
	puthex(cmd);
	puthex(arg>>16);
	puthex(arg);
	puts(")");
    #endif
    /* some MMC brands require the extra clock pulses     */
    SpiSendClocks();
    SpiSendClocks();
    USEX(GPIO_ODATA) &= ~SPI_xCS2;
  
    while (SpiSendReceiveMmc(0xff00,8) != 0xff) {
	/* Unexpected busy signal from MMC */
        #ifdef USE_DEBUG
	    putchar('u');
            putchar('\n');
        #endif
    }
    SpiSendReceiveMmc(cmd, 16); /* top half normally 0xff */
    SpiSendReceiveMmc(arg>>16, 16);
    SpiSendReceiveMmc(arg, 16);
    t = SpiSendReceiveMmc(0x9500, 8);    /* Valid CRC for init, then don't care */
  
    cmd = 100;               /* timeout value, try max. 100 times */
    while (cmd && (t & 0x80)) { /* R1 response not detected */
	t = SpiSendReceiveMmc(0xff00, 8);
	cmd--;               /* decrease the timeout value */
    }
    #ifdef USE_DEBUG
        puthex(t);
        putchar('\n');
    #endif
    return t;
}
#endif

#if 1
auto void ReadDiskSectorTo(register __a u_int32 sector, register __i2 u_int16 *buffer);
#else
auto void ReadDiskSectorTo(register __a u_int32 sector, register __i2 u_int16 *buffer) {
    register s_int16 i;
  
    #if 0 && defined(USE_DEBUG)
        //puthex(sector>>16);
        puthex(sector);
        puts(" SECTOR");
    #endif

    MmcCommand(MMC_READ_SINGLE_BLOCK|0x40,(sector&0x7fffffffUL)<<mmc.hcShift);
    do {
        i = SpiSendReceiveMmc(0xff00,8);
        #if 0 && defined(USE_DEBUG)
          puthex(i);
          puts(" wait");
        #endif
    } while (i == 0xff);

    #if 0
      if (i != 0xfe) {
          SpiSendClocks();/*USEX(GPIO_ODATA) |= SPI_xCS2;*/
          #ifdef USE_DEBUG
            puts("wfd fail");
          #endif
          return;
      }
    #endif
    
    for (i=0; i<512; i+=2) {
        *buffer++ = SpiSendReceiveMmc(0xffff,16);
    }
    SpiSendReceiveMmc(0xffff,16); /* discard crc */

    /* generate some extra SPI clock edges to finish up the command */
    SpiSendClocks();
    SpiSendClocks();
    return;
}
#endif

#if 0
/* Note: sector is not logical sector number, it is directly MMC argument */
auto void WritePhysicalSectorY(register __d u_int32 sector,
			       register __i3 __y u_int16 *dataBufPtr) {
    register u_int16 c;
    s_int16 to = 0;

    c = MmcCommand(MMC_WRITE_BLOCK|0x40, sector & 0x7fffffff);
    while (c != 0x00) {
	//wait for BUSY token, if you get 0x01(idle), it's an ERROR!
	c = SpiSendReceiveMmc(0xff00, 8);
//putch(c);
	to++;
	if (c == 0x01 || to < 0) {
	    return; //ERROR
	}
    }
    //MMC_XCS = MMC_SELECTED;
    SpiSendReceiveMmc(0xfffe, 16);
    for (c=0;c<256;c++) {
	SpiSendReceiveMmc(*dataBufPtr++, 16);
    }
    SpiSendReceiveMmc(0xffff, 16); /* send CRC */
    
    //c = SPIGetChar(); //This prints xxx00101, (usually e5) when data ok
    #ifdef USE_DEBUG
      c = SpiSendReceiveMmc(0xff00, 8);
      puthex2(c);
      putstrp("\p response");
    #endif
    #if 0
      while ( SpiSendReceiveMmc(0xff00, 8) != 0xff)
	  ;
      SpiSendReceiveMmc(0xffff, 16);
      SpiSendReceiveMmc(0xffff, 16);
      SpiSendClocks();
      SpiSendClocks();
    #endif
} 
#endif
