#ifndef ASMFUNCS_H
#define ASMFUNCS_H

#ifdef __VSDSP__

void WriteToProgramRam(register __i0 addr,
		       register __a1 msB, register __a0 lsB);
u_int32 ReadFromProgramRam(register __i0 addr);
u_int32 ReadIMem(register __i0 u_int16 addr);
void WriteIMem(register __i0 u_int16 addr, register __a u_int32 code);
auto void Sleep(void);
auto void StereoCopy(register __i2 s_int16 *s, register __a0 u_int16 n);
auto void StereoCopy1053(register __i2 s_int16 *s, register __a0 u_int16 n);
auto void OldStereoCopy(register __i2 s_int16 *s, register __a0 u_int16 n);

auto void Up1(register __i0 s_int16 *p, register __a0 u_int16 len);
auto void Down123(register __i0 s_int16 *p, register __a0 u_int16 len,
		  register __a1 u_int16 n);
auto void Up1Y(register __i0 __y s_int16 *p, register __a0 u_int16 len);
auto void DownNY(register __i0 __y s_int16 *p, register __a0 u_int16 len,
		  register __a1 u_int16 n);
auto s_int16 SatUp1(register __a0 s_int16 n);
auto s_int16 SatUp2(register __a0 s_int16 n);

auto u_int16 TestIRom(register __i0 u_int16 startAddr,
		      register __a1 u_int16 size);
auto u_int32 TestIRam(register __i0 u_int16 start,
		      register __i1 u_int16 len,
		      register __a u_int32 pat);
auto u_int16 TestXRam(register __i0 u_int16 start,
		      register __i1 u_int16 len,
		      register __a0 u_int16 pat);
auto u_int16 TestYRam(register __i0 u_int16 start,
		      register __i1 u_int16 len,
		      register __a0 u_int16 pat);
/* Y:upper word, X:lower word */
auto u_int32 TestXYRam(register __i0 u_int16 start,
		       register __i1 u_int16 len,
		       register __a u_int32 pat);
void Disable(void);	/* NOT auto */
void Enable(void);	/* NOT auto */

void rle_sdi_int(void);
void sdi_int(void);

/** Configures ADC and  SDM input with the same rates, enables
    SDM interrupt and copies ADC->SDM with volume control.
   \param rate Requested rate: 0=192k, 1=96k, 2=48k, 3=24k.
   \param mode Requested operating mode: 0=stereo,1=mono,2=left,3=right
*/
void ADMixerEnable(register __c0 s_int16 rate, register __c1 s_int16 mode);
void ADMixerDisable(void);

/*Uses bssWp, bssEnd, bssStart */
void PutBss(register __a0 s_int16 val);

void CallDctTest(void);
u_int32 CompareXY(register __i0 void *a, register __i2 void *b, register __a0 n);
void CopyXY(register __i0 void *d, register __i2 void *s, register __a0 n);

void flacStreamBufferExtend(void);
void flacStreamBufferRestore(void);
#endif

#endif
