#ifndef VSBASS_H
#define VSBASS_H

#include <vstypes.h>

#define BASS_SAMPLE_BLOCK 64
auto void Bass(s_int16 *samples, register __a0 s_int16 n);
void SetBass(register __c0 u_int16 sFreq, register __c1 u_int16 low,
	     u_int16 compMaxG, u_int16 trebleG);

/* Read and write interleaved data.
   Input in lpData. Higpass->data, Lowpass->lpData */
auto void FilterI(register __i0 s_int16 __y *data,
                 register __i1 s_int16 *lpData,
                 register __a0 s_int16 n,
                 register __i2 __y s_int32 *z,
                 register __i3 const u_int16 __y *g);
/* Compand interleaved channels. */
auto void CompandI(register __i0 s_int16 *d, register __a0 s_int16 n,
		   register __a1 u_int16 maxG,
		   register __i1 __y struct BassCompand *bc);
/* interleaved input */
auto void Filter1I(register __i0 s_int16 *data,
                 register __a0 s_int16 n,
                 register __i2 __y s_int32 *z,
                 register __i3 const u_int16 __y *g);
auto void Combine2(register __i0 s_int16 *dData,
		  register __i2 s_int16 __y *sData,
		  register __a0 s_int16 n);

#endif
