#ifndef __ENCODERS_H__
#define __ENCODERS_H__

#define ENCMODE_ADPCM      0
#define ENCMODE_LPCM       1
#define ENCMODE_G711_ULAW  2
#define ENCMODE_G711_ALAW  3
#define ENCMODE_G722       4
#define ENCMODE_OGGVORBIS  5
#define ENCMODE_MP3        6

#define AICTRL3_CODECMODE  0x8000
#define AICTRL3_ENABLEAEC  0x4000
#define AICTRL3_ENABLEUART 0x2000
//#define AICTRL3_ENABLEVOX  0x1000
#define AICTRL3_PAUSEON    0x0800
#define AICTRL3_NORIFF     0x0400 //no RIFF WAV header expected or inserted
#define AICTRL3_STEREO      0
#define AICTRL3_DUALCHANNEL 1
#define AICTRL3_LEFT        2
#define AICTRL3_RIGHT       3
#define AICTRL3_MONOMIX     4
#define AICTRL3_IMAADPCM   (ENCMODE_ADPCM<<4)
#define AICTRL3_PCM        (ENCMODE_LPCM<<4)
#define AICTRL3_ULAW       (ENCMODE_G711_ULAW<<4)
#define AICTRL3_ALAW       (ENCMODE_G711_ALAW<<4)
#define AICTRL3_G722ADPCM  (ENCMODE_G722<<4)
#define AICTRL3_VORBIS     (ENCMODE_OGGVORBIS<<4)
#define AICTRL3_MP3        (ENCMODE_MP3<<4)

#ifndef ASM
extern s_int16 codecMode; /* bit 0 controls ADC interrupt data routing
			     bit 0: 0 = encoder mode (data to audio buffer),
		                    1 = codec mode (to src buffer directly) */

extern volatile u_int16 __y *bssWp, *bssRp, *bssStart, *bssEnd, bssSize, bssRdOdd, bssWrOdd;
extern volatile s_int16 *srcWp, *srcRp;
extern volatile u_int16 srcModulo;

extern u_int16 g_dctlo[2048];
extern __y u_int16 g_dcthi[2048];
extern s_int16 g_yprev0[1024];
extern s_int16 g_yprev1[1024];

/*using AGC() */
struct AdcControl {
    struct AGC agc[2];
    s_int16 adcMode;
    s_int16 encMode;
};
//extern struct AdcControl adcControl;

auto void SetImaFill(void);
auto s_int16 SearchForImaHeader(s_int16 chans); /*in playwav.c */
void Encoders(void);

/* In ROM */
extern const __y s_int16 imaDownSampleBy3[102];
extern const __y s_int16 imaDownSampleBy2[64];

extern const u_int16 encoderFormatTag[];
//    WAVE_FORMAT_IMA_ADPCM,    WAVE_FORMAT_PCM,    WAVE_FORMAT_MULAW,
//    WAVE_FORMAT_ALAW,    WAVE_FORMAT_G722_ADPCM,    0, 0
extern const s_int16 encoderBitsPerSample[];
//    4, 16, 8, 8, 4, 0, 0

#endif/*!ASM*/

#endif /*!__ENCODERS_H__*/
