#ifndef IMA_H
#define IMA_H

#include <vstypes.h>

#define ISSTMAX 88
#define IMA_ENCODE_BLOCK_ALIGN 256
#define IMA_ENCODE_SAMPLES (2*IMA_ENCODE_BLOCK_ALIGN-7)
#define IMA_ENCODE_BSSPACE (IMA_ENCODE_BLOCK_ALIGN*4) // must be power of 2

auto void ImaEncode(void);
#ifdef VS1053
extern u_int16 __y *bssWp, *bssRp, *bssStart, *bssEnd;
#else
extern u_int16 __y *bssWp, *bssRp;
#endif

auto void SetImaFill(void);
/*
  Downsamples two channels: left in a1, right in a0
  Input to ImaDownSample() must be aligned correctly
  according to bufSize parameter.
 */
auto s_int32 ImaDownSampleVariable(register __i0 const s_int16 *buf,
				   register __c0 s_int16 bufSize,
				   register __i1 const __y s_int16 *coeff,
				   register __a0 s_int16 n,
				   register __a1 u_int16 gain /*32768U = 1.0*/);

#endif
