#ifndef STREAM_H
#define STREAM_H

#include "hardware.h" //for STREAM_BUFFER_SZ

#ifdef ASM

#else/*ASM*/

#include <vstypes.h>

#ifdef __VSDSP__
extern volatile __x u_int16 * __y stream_rd_pointer;
extern volatile __x u_int16 * __y stream_wr_pointer;
extern volatile s_int16 __y stream_rd_odd;
extern __x u_int16 streamBuffer[STREAM_BUFFER_SZ];
extern u_int16 stream_buffer[];
#else
extern volatile u_int16 *stream_rd_pointer;
extern volatile u_int16 *stream_wr_pointer;
extern volatile s_int16 stream_rd_odd;
extern u_int16 streamBuffer[STREAM_BUFFER_SZ];
extern u_int16 stream_buffer[];
#endif

#ifdef STANDALONE

#else /*STANDALONE*/
auto void StreamOpen(const char *name);
auto void StreamClose(void);
#endif /*elseSTANDALONE*/

/* reads bytes into the array */
auto s_int16 myfread(unsigned char *ptr, s_int16 n);
/* reads packed bytes */
auto s_int16 my16fread(u_int16 __y *ptr, s_int16 n);

auto s_int16 StreamInit(void);
auto s_int16 StreamDiff(void);
auto s_int16 StreamHeadRead(u_int32 __y *newhead);
auto s_int16 StreamHeadShift(u_int32 __y *head);
auto s_int16 StreamSkipBytes(s_int32 len);
auto s_int16 StreamReadFrameBody(u_int16 __y *buf, s_int16 size);

auto s_int16 MyGetC(void);
auto void MyGetCPairs(register __i0 __y u_int16 *p, register __a0 s_int16 n);
auto void WaitForData(register __c0 u_int16 n);

#ifdef USE_VORBIS
auto s_int16 ReadStream(register __i3 u_int16 *buf,
			register __c1 s_int16 byteOff,
			register __c0 s_int16 byteSize);
#endif/*USE_VORBIS*/
auto void ymemset(unsigned char __y *d, int c, u_int16 len);
void OutOfStreamData(void);

#endif /*elseASM*/

#endif /* !STREAM_H*/
