#include <vs1063.h>

	.sect code,CallEncoders
	.export _CallEncoders
_CallEncoders:
	.import _CallIROM4,_Encoders
#if 1
	ldc 0xc726,le	//only catch the mp3 encoder
	ldc createMp3Enc,ls
	ldc 1,lc
	call _CallIROM4
	ldc _Encoders,a0
	//Encoders() never returns, so don't bother with saving registers!
#else
	//we always start from reset, so no channel swap problem.
	ldc 0xc6d3,le
	ldc $1,ls
	ldc 1,lc
	call _CallIROM4
	ldc _Encoders,a0
	//Encoders() never returns, so don't bother with saving registers!

$1:	.import _DecimCheck
	call _DecimCheck	//Check for and correct channel swap
	nop

	ldc 0xc726,le
	ldc createMp3Enc,ls
	j 0xc6d4
	ldc 1,lc
#endif



createMp3Enc:
	CALL 0xd5d3      /* _EncMp3Create */
	nop
	//replace the encode function
	ldc _EncMp3EncodeNew,i5
	LDC 0x237d+2,I7    /* _encoderMp3+2 */
	j 0xc733   /* section Encoders + 0x1cc */
	stx i5,(i7)


	//.sect code,EncMp3EncodeNew
_EncMp3EncodeNew:
#if 0
	//Encoders() does not use loop hw, and we know where we return,
	// so don't bother saving the old values..
	ldc encLoopSave,i7	//separate save because we have stack params!
	stx lr0,(i7)+1
	stx lc,(i7)+1
	stx ls,(i7)+1
	stx le,(i7)
#endif

//Code jumps to 0xd726, which checks two-conditional while condition.
//Function either exits through 0xd7e2, or continues to 0xd734.
//d6df..d708->d726
//d709..d70b->d802 if channels==1
//d70d..d713
//d714..
//d718..d71d->d726 granulecheck
//d71e..d725 EncMJoinAndQuantize & OUR! _EncMEmitFrame
//d726 while check
//d734 while body, keep looping
//d741->d7df
//d743..
//d753->d7d1
//d755..
//d75e ch loop1 check
//d763->d782
//d765..d781->d75e
//d782 hybridPhase check
//d785->d726 (while)
//d787..
//d794 ch loop2 check
//d798->d709
//d79a..9e..b8 hybrid (18) loop
//d9b9..d7d0->d794
//d7d1..d7de->d759 samplesLeft =
//d7df..d7e1->d759 samplesLeft -= 32
//d802..d812->d714 minHybridSh ('subroutine')


	ldc 0xc747,lr0		//return there! (from ROM)
	ldc 1,lc
	ldc 0xd797,le
	j 0xd6df
	ldc epatch,ls

	//patch here!
epatch:
//     for (ch=0; ch<encoderMp3.e.channels; ch++) {

/*d798*/
	ldc 2,lc
	ldc 0xd71b,le
	ldc epatch2,ls

	JCS 0xd709	//always ends up in 0xd71b
	LDC 0x1,A1

	ADD A1,ONES,A0 ; LDX (I4)+4,NULL
	AND NULL,NULL,B1 ; STY A0,(I4)-4

//replace one LOOP

	ldc 0x12+1,lc
$0:	ldc 0xd7b8,le
	j 0xd79e
	ldc @+1,ls	//call ...
	ldc 0x12,c1
	sub b1,c1,c1
	ldc epatch,ls	//re-install patch point!
	jzc $0
	ldc 0xd797,le

	j 0xd7b9	//always ends up in 0xd797, we catch it with loophw
	ldc 0x20,c1	//restore c1

epatch2:
	ldc epatch,ls	//re-install!
	ldc 0xd797,le

	JLT 0xd726	//continue to while loop
	ldc 2,lc

#if 0
	//debug output to DECODETIME
	ldc 0xc004,i7
	ldx (i7),i5
	ldx (i5)+1,null
	stx i5,(i7)
#endif

	LDC 0xf,I5
	LDX (I4)*,NULL
	LDC 0xfff1,I5
	AND NULL,NULL,C0 ; MV I4,I1	//i1 = i4+15

	//auto void EncMJoinAndQuantize(register __i1 s_int16 *sh) {
	ldc quantpatch,ls
	ldc 0xe6bc,le
	ldc 22,lc

	CALL 0xe61f      /* _EncMJoinAndQuantize */
	LDX (I4)*,NULL ; LDY (I6)+1,NULL

	CALL L0xdbf6      /*OUR! _EncMEmitFrame */
	LDX (I6)+1,NULL

#if 0
	//debug output to DECODETIME
	ldc 0xc004,i7
	ldx (i7),i5
	ldx (i5)+1,null
	stx i5,(i7)
#endif

	//out EncMEmitFrame used loop hw, so reinstall
	ldc 2,lc
	ldc epatch,ls	//re-install!
	ldc 0xd797,le
	jmpi 0xd726

#if 0
leavepatch:
	ldc encLoopSave,i7	//separate save because we have stack params!
	ldx (i7)+1,lr0
	ldx (i7)+1,lc
	ldx (i7)+1,ls
	ldx (i7),le
	jr
	nop
#endif

quantpatch:
	ldc 0x3647,i7
	ldx (i7),a1

	call 0xe0f2 //_EncMQuantize
	sty a1,(i6)+1	; ldx (i0),a1

	ldc 0x3647,i7
	ldy (i6)-1,a0
	stx a0,(i7)

	j 0xe6bf
	ldc 22,lc


	.sect code,EncMEmitFrame
//We are not called from inside a loop and caller saves loop hw
L0xdbf6:	ldc 0xdc04,le	//FROM = 0xdc8f
		ldc 1,lc
		j 0xdbf6	//ROM
		ldc @+1,ls
//dbf6..dc05
/*L0xdc05*/	jzc L0xdc07
		NOP

//if (!encoderMp3.format) // optimize scf compression
L0xdf3f:	LDC 0x0,B0
//
L0xdf40:	LDC 0x2384,I0    /* _encoderMp3 + 0x7 */
L0xdf41:	LDX (I0),A0 ; LDY (I6)+1,NULL
L0xdf42:	SUB B0,A0,A0
L0xdf43:	LDC 0x239a,I0    /* _encoderMp3 + 0x1d */
L0xdf44:	JCS L0xdc08       /* section EncMEmitFrame + 0x12 */
L0xdf45:	LDX (I0)+1,A1

		LDC 4,LC
		LDX (I6)-1,NULL
		LDC 0x0,A1
		ldc 0xdf7f,le
		j 0xdf4a
		ldc @+1,ls
		j 0xdf4a
		ldc @+1,ls
		j 0xdf4a
		ldc @+1,ls
		j 0xdf4a
		ldc @+1,ls

L0xdf80:	J L0xdf40         /* section EncMEmitFrame + 0x34a */
L0xdf81:	SUB B0,ONES,B0


//no scf compression
L0xdc07:	LDX (I0)+1,A1 ; LDY (I6)+1,NULL
//done scf compression
L0xdc08:	LDX (I0),A0

		ldc 0xdc89,le
		ldc 1,lc
		j 0xdc09	//ROM
		ldc @+1,ls

L0xdc8a:	JZS L0xdf2a       /* section EncMEmitFrame + 0x334 */
L0xdc8b:	NOP	//uses loop! outputs scfsi, returns to L0xdc8c

L0xdc8c:	J L0xdc8f         /* section EncMEmitFrame + 0x99 */
L0xdc8d:	AND NULL,NULL,D0



L0xdc8e:	SUB D0,ONES,D0
//for (gr=0; gr<encoderMp3.granules; gr++) {
L0xdc8f:	LDC 0x238c,I0    /* _encoderMp3 + 0xf */
L0xdc90:	LDX (I0),A0
L0xdc91:	SUB D0,A0,A0
L0xdc92:	NOP
L0xdc93:	JGE L0xdd37       /* section EncMEmitFrame + 0x141 */
L0xdc94:	NOP

L0xdc95:	LDC 0x0,B1
//for (ch=0; ch<encoderMp3.e.channels; ch++) {
L0xdc96:	LDC 0x2384,I0    /* _encoderMp3 + 0x7 */
L0xdc97:	LDX (I0),A0
L0xdc98:	SUB B1,A0,A0
L0xdc99:	NOP
L0xdc9a:	JCS L0xdc8e       /* section EncMEmitFrame + 0x98 */
L0xdc9b:	NOP

		ldc 0xdccc,le
		ldc 1,lc
		j 0xdc9c	//ROM
		ldc @+1,ls

L0xdccd:	JZS L0xdd12       /* section EncMEmitFrame + 0x11c */
L0xdcce:	NOP

L0xdccf:	CALL 0xda67      /* _EncMOutBits16 */
L0xdcd0:	AND NULL,NULL,A0 ; LDX (I6)+1,NULL

//	for (region=0; region<2; region++) {

		LDC 0x0,B0
		ldc 2,lc
		ldc 0xdce5,le
		j 0xdcd4	//loop once
		ldc @+1,ls
		j 0xdcd4	//loop twice
		ldc @+1,ls

//for (window=0; window<3; window++)

		LDC 0x0,B0
		ldc 3,lc
		ldc 0xdcf6,le
		j 0xdce9	//loop once
		ldc @+1,ls
		j 0xdce9	//loop twice
		ldc @+1,ls
		j 0xdce9	//loop thrice
		ldc @+1,ls

//if (!encoderMp3.format)
L0xdcf7:	ldc 0xdd0d,le
		ldc 1,lc
		j 0xdcf7	//ROM
		ldc @+1,ls

L0xdd0e:	CALL 0xda67      /* _EncMOutBits16 */
L0xdd0f:	LDX (I0),A0
L0xdd10:	J L0xdc96         /* section EncMEmitFrame + 0xa0 */
L0xdd11:	SUB B1,ONES,B1


//	for (region=0; region<3; region++) {
L0xdd12:	LDC 0x0,B0
		ldc 3,lc
		ldc 0xdd26,le
		j 0xdd15	//loop once
		ldc @+1,ls
		j 0xdd15	//loop twice
		ldc @+1,ls
		j 0xdd15	//loop thrice
		ldc @+1,ls


		ldc 0xdd34,le
		ldc 1,lc
		j 0xdd27	//ROM
		ldc @+1,ls

L0xdd35:	CALL 0xda67      /* _EncMOutBits16 */
L0xdd36:	LDC L0xdcf7,LR0   /* section EncMEmitFrame + 0x101 */

L0xdd37:	ldc 0xdd40,le
		ldc 1,lc
		j 0xdd37	//ROM
		ldc @+1,ls

L0xdd41:	JZC L0xdd44       /* section EncMEmitFrame + 0x14e */
L0xdd42:	NOP
L0xdd43:	LDC 0x2a,A0
L0xdd44:	CALL 0xdb13      /* _EncMSetBitBytePtr */
L0xdd45:	LDX (I6)+1,NULL
L0xdd46:	J L0xdd49         /* section EncMEmitFrame + 0x153 */
L0xdd47:	AND NULL,NULL,D1

//  for (gr=0; gr<encoderMp3.granules; gr++) {
L0xdd48:	SUB D1,ONES,D1
//
L0xdd49:	LDC 0x238c,I0    /* _encoderMp3 + 0xf */
L0xdd4a:	LDX (I0),A0
L0xdd4b:	SUB D1,A0,A0
L0xdd4c:	NOP
L0xdd4d:	JGE 0xde0e	//ROM return /* section EncMEmitFrame + 0x218*/
L0xdd4e:	NOP

L0xdd4f:	J L0xdd8f         /* section EncMEmitFrame + 0x199 */
L0xdd50:	AND NULL,NULL,D0



L0xdd51:	ldc 0xdd76,le
		ldc 1,lc
		j 0xdd51	//ROM
		ldc @+1,ls

L0xdd77:	JLE L0xdd81       /* section EncMEmitFrame + 0x18b */
L0xdd78:	NOP

L0xdd79:	ADD B1,ONES,B1
L0xdd7a:	LOOP B1,L0xdd80   /* section EncMEmitFrame + 0x1018a */
L0xdd7b:	NOP
//loop start
L0xdd7c:	MV I0,I1
L0xdd7d:	MV I3,I2
L0xdd7e:	CALL 0xe9eb      /* _EncMHuff4 */
L0xdd7f:	LDX (I6)+1,NULL
L0xdd80:	LDX (I3)+4,NULL
//loop end

L0xdd81:	CALL 0xdad1      /* _EncMGetBitPtr */
L0xdd82:	LDX (I6)+1,NULL
L0xdd83:	LDX (I4)+2,NULL ; LDY (I6)+1,NULL
L0xdd84:	ADD A0,NULL,A1 ; LDX (I4)-2,A0
L0xdd85:	SUB A1,A0,B1
L0xdd86:	ADD D1,D1,A0
L0xdd87:	LDC 0x23ad,A1    /* _encoderMp3 + 0x30 */
L0xdd88:	ADD A1,A0,A0
L0xdd89:	LDC 0xc,A1
L0xdd8a:	ADD A0,D0,A0
L0xdd8b:	ADD B1,NULL,A0 ; MV A0,I0
L0xdd8c:	CALL 0xdaf5      /* _EncMInsertBits */
L0xdd8d:	LDX (I0),B0
L0xdd8e:	SUB D0,ONES,D0 ; STX B1,(I0)

//    for (ch=0; ch<encoderMp3.e.channels; ch++) {
L0xdd8f:	LDC 0x2384,I0    /* _encoderMp3 + 0x7 */
L0xdd90:	LDX (I0),A0
L0xdd91:	SUB D0,A0,A0
L0xdd92:	NOP
L0xdd93:	JCS L0xdd48       /* section EncMEmitFrame + 0x152 */
L0xdd94:	NOP

//	const u_int16 *sBand = encMScfsiBand[0];
L0xdd95:	CALL 0xdad1      /* _EncMGetBitPtr */
L0xdd96:	LDX (I6)+1,NULL
L0xdd97:	LDC 0x968d,I0    /* _encMScfsiBand */
L0xdd98:	AND NULL,NULL,C0 ; LDX (I4)+2,NULL
L0xdd99:	AND NULL,NULL,B0 ; STX A0,(I4)-2

//	  for (scfsiBandNo = 0; scfsiBandNo < 4; scfsiBandNo++) {
L0xdd9a:	LDC 0x4,A0
L0xdd9b:	SUB C0,A0,A0
L0xdd9c:	LDC 0x6,A0
L0xdd9d:	JGE L0xddd2       /* section EncMEmitFrame + 0x1dc */
L0xdd9e:	NOP

L0xdd9f:	ADD D0,D0,A0 ; LDX (I0)+1,C1
L0xdda0:	ADD A0,A0,A1
L0xdda1:	LDC 0x23a5,A0    /* _encoderMp3 + 0x28 */
L0xdda2:	ADD A0,A1,A0
L0xdda3:	ADD A0,C0,A0
L0xdda4:	MV A0,I2
L0xdda5:	LDX (I2),A0
L0xdda6:	SUB A0,NULL,A0
L0xdda7:	NOP
L0xdda8:	JZS L0xddb1       /* section EncMEmitFrame + 0x1bb */
L0xdda9:	NOP
L0xddaa:	SUB D1,NULL,D1
L0xddab:	NOP
L0xddac:	JZS L0xddb1       /* section EncMEmitFrame + 0x1bb */
L0xddad:	NOP

L0xddae:	SUB C1,ONES,B0
L0xddaf:	J L0xdd9a         /* section EncMEmitFrame + 0x1a4 */
L0xddb0:	SUB C0,ONES,C0

L0xddb1:	SUB C1,B0,A0
L0xddb2:	NOP
L0xddb3:	JLT L0xddae       /* section EncMEmitFrame + 0x1b8 */
L0xddb4:	NOP

L0xddb5:	LOOP A0,L0xddcf   /* section EncMEmitFrame + 0x101d9 */
L0xddb6:	NOP
//loop start
L0xddb7:	LDC 0x8,A0
L0xddb8:	LDC 0x16,B1
L0xddb9:	LDX (I4)+1,NULL ; LDY (I6)+1,NULL
L0xddba:	MULSS D1,A0 ; STX C0,(I4) ; STY C1,(I4)
L0xddbb:	ADD NULL,P,A
L0xddbc:	LDC 0x23c1,A1    /* _encoderMp3 + 0x44 */
L0xddbd:	ADD A1,A0,A1
L0xddbe:	ADD D0,D0,A0
L0xddbf:	ADD A0,A0,A0
L0xddc0:	ADD A1,A0,A0
L0xddc1:	ADD A0,C0,A0
L0xddc2:	ADD B1,B1,A0 ; MV A0,I2
L0xddc3:	MULSS D1,A0 ; LDX (I2),A1
L0xddc4:	LDC 0x2415,A0    /* _encoderMp3 + 0x98 */
L0xddc5:	ADD NULL,P,C
L0xddc6:	ADD A0,C0,A0
L0xddc7:	MULSS D0,B1
L0xddc8:	ADD NULL,P,C
L0xddc9:	MV C0,B1
L0xddca:	ADD A0,C0,A0 ; LDX (I4),C0
L0xddcb:	ADD A0,B0,A0 ; LDY (I4)-1,C1
L0xddcc:	MV A0,I2
L0xddcd:	CALL 0xda67      /* _EncMOutBits16 */
L0xddce:	LDX (I2),A0
L0xddcf:	SUB B0,ONES,B0
//loop end
L0xddd0:	J L0xddae         /* section EncMEmitFrame + 0x1b8 */
L0xddd1:	NOP


L0xddd2:	ldc 0xddf0,le
		ldc 1,lc
		j 0xddd2	//ROM
		ldc @+1,ls

L0xddf1:	LDC 0x3,A1
L0xddf2:	SUB B0,A1,A1
L0xddf3:	NOP
L0xddf4:	JGE L0xdd51       /* section EncMEmitFrame + 0x15b */
L0xddf5:	SUB A0,C1,A1
L0xddf6:	NOP
L0xddf7:	JGE L0xdd51       /* section EncMEmitFrame + 0x15b */
L0xddf8:	NOP
L0xddf9:	LDX (I3),A1 ; LDY (I4)+4,NULL
L0xddfa:	SUB A1,C1,B1 ; LDY (I6)+1,NULL
L0xddfb:	NOP
L0xddfc:	JLT L0xddff       /* section EncMEmitFrame + 0x209 */
L0xddfd:	NOP
L0xddfe:	MV C1,A1
L0xddff:	STX D0,(I4) ; STY D1,(I4)-3
L0xde00:	SUB A1,A0,B1 ; STX B0,(I4) ; STY C0,(I4)
L0xde01:	LDC 0x6,A0
L0xde02:	ASR B1,B0 ; LDX (I0)+1,C0
L0xde03:	MULSS C0,A0 ; LDY (I4),C0
L0xde04:	LDC 0x9000,A0    /* _huffEnc2 */
L0xde05:	ADD NULL,P,D ; MV C0,I2
L0xde06:	ADD A0,D0,A0
L0xde07:	ADD B0,NULL,A0 ; MV A0,I1
L0xde08:	LDX (I4)+3,B0

#if 0
	//debug output to DECODETIME
	ldc 0xc004,i7
	ldx (i7),i5
	ldx (i5)+1,null
	stx i5,(i7)
#endif
		//EncMHuff2N uses loop, but not the branch we need to patch!
		ldc 0xe962,le	//ASHL C,A1,C
		ldc 200,lc
		ldc $0,ls
		LDX (I4),D0 ; LDY (I4)-4,D1
		call 0xe91c      /* _EncMHuff2N */
		ldc L0xde0b,lr0

$0:		ldc 0x7ff,a1		//code &= 0x7ff;
		j 0xe963
		and a0,a1,a0


L0xde0b:	ADD C0,B1,C0 ; LDX (I3)+1,NULL
L0xde0c:	J L0xddf1         /* section EncMEmitFrame + 0x1fb */
L0xde0d:	SUB B0,ONES,B0 ; MV A1,A0


#if 0
//'subroutine' at the beginning: output scfsi, return to L0xdc8c
L0xdf2a:
	LDC 0x0,B0
L0xdf2b:
	LDC 0x2384,I0    /* _encoderMp3 + 0x7 */
	LDX (I0),A0
	SUB B0,A0,A0
	NOP
	JCS L0xdc8c       /* section EncMEmitFrame + 0x96 */
	NOP
	LDC 4-1,LC
	LOOP LC,L0xdf3d-1   /* section EncMEmitFrame + 0x10346 */
	LDC 0x0,B1
//loop start
	LSL B0,A0 ; LDY (I6)+1,NULL
	LSL A0,A1
	LDC 0x23a5,A0    /* _encoderMp3 + 0x28 */
	ADD A0,A1,A0
	ADD A0,B1,A0
	SUB NULL,ONES,A1 ; MV A0,I0	// 0x23a5+4*b0(0..@0x2384)+1*b1(0..3)
	CALL 0xda67      /* _EncMOutBits16 */
	LDX (I0),A0
	SUB B1,ONES,B1
//loop end
L0xdf3d:
	J L0xdf2b         /* section EncMEmitFrame + 0x335 */
	SUB B0,ONES,B0
//end of 'subroutine'
#else
//'subroutine' at the beginning: output scfsi, return to L0xdc8c
L0xdf2a:
	LDC 0x0,B0
	LDC 0x23a5,I0    /* _encoderMp3 + 0x28 */
L0xdf2b:
	LDC 0x2384,I5    /* _encoderMp3 + 0x7 */
	LDX (I5),A0
	SUB B0,A0,A0
	NOP
	JCS L0xdc8c       /* section EncMEmitFrame + 0x96 */
	NOP

	LDC 4-1,LC
	LOOP LC,L0xdf3d-1   /* section EncMEmitFrame + 0x10346 */
	SUB NULL,ONES,A1
//loop start
	CALL 0xda67      /* _EncMOutBits16 */
	LDX (I0)+1,A0	 ; LDY (I6)+1,NULL
	SUB NULL,ONES,A1 //required
//loop end
L0xdf3d:
	J L0xdf2b         /* section EncMEmitFrame + 0x335 */
	SUB B0,ONES,B0
//end of 'subroutine'
#endif


	.end
